###################################################################################################################################################
# Copyright 2018 Orchid Systems 
# -----------------------------
# Permitted for use with Orchid Systems Modules only.
# The code is supplied on an as is basis for training and demonstration purposes only and is not supported by Orchid Systems.
# If this code is deployed in a live production environment it is the responsibility of the End User to ensure 
# that it is operating as required.
# -------------------
# Updated: 2018/08/23 - includes system access to check to prevent script from running during D.I.C, Import, Export, etc.
###################################################################################################################################################

from accpac import *

# This sample script exports OE Shipments to a file.
# It could be used to interface with a warehousing program.

# onOpen is called when the view is opened.
# Return Continue to enable the macro.
# Return 0 to disable the macro.
# If you return anything else then the view will not load.
def onOpen():
	if rotoID != "OE0692":
		showError("This script is intended for OE0692 (OESHIH) only")
		return 0 # don't do anything since the view is not OESHIH
		
	# Check system access to prevent running the script during Data Integrity Check, Import, Export, etc:
	if int(me.getAccess()) != 0:
		return 0.# do not run the script. System Access is not Normal.
		
	return Continue

def onAfterInsert(result):
	if result != 0:
		return
	ExportShipment()

def onAfterUpdate(result):
	if result != 0:
		return
	ExportShipment()

def ExportShipment():
	f = open("c:\\warehouse\\" + me.get("SHINUMBER") + ".txt", "w")
	h = View("OE0692", 1)
	d = View("OE0691", 1)
	h.order(1) # SHINUMBER
	h.put("SHINUMBER", me.get("SHINUMBER"), 1)
	h.read()
	f.write("H," + h.get("LOCATION") + "," + h.get("BILADDR1") + "\n")
	d.browse("SHIUNIQ=" + "{:.0f}".format(h.get("SHIUNIQ")), 1)
	while (d.fetch() == 0):
		f.write("D," + d.get("ITEM") + "," + "{:.0f}".format(d.get("QTYSHIPPED")) + "\n")
	f.close()
